/*
 * $Project: dedit Disk EDITor for X680x0 $
 * $Copyright: 1989-1993 by d(T.Kawamoto) $
 * $Source: /home/src/cvs/dedit/diskbios.h,v $
 * $Author: kawamoto $
 * $Revision: 1.2 $
 * $Date: 1993/10/24 18:35:11 $
 * $Log: diskbios.h,v $
 *	Revision 1.2  1993/10/24  18:35:11  kawamoto
 *	*** empty log message ***
 *
 *	Revision 1.1  1993/10/24  17:40:40  kawamoto
 *	version 2.24 first cvs importing
 */

/*
 *	diskbios
 *		for X68k
 *	Copyright 1989 1990 by T.Kawamoto
 *
 *	diskbios.h
 *
 */
/* diskbios.s */
#define CMD_PARAM_BUF struct cmd_param_buf
CMD_PARAM_BUF {
  uchar *buf_ptr;
  unsigned short buf_len;
  uchar cmd, drive, disktype, track, duplicate;
  uchar params[7];
  uchar results[3], C, H, R, N;
};

#define CMD_SET_HEAD	  0
#define CMD_READ_DIAG	  2
#define CMD_WRITE_DATA	  5
#define CMD_READ_DATA	  6
#define CMD_WRITE_DDATA	  9
#define CMD_READ_ID	 10
#define CMD_READ_DDATA	 12
#define CMD_WRITE_ID	 13
#define CMD_SEEK	 15

#define OPT_SET_HEAD	 16
#define OPT_SKIP	 32
#define OPT_MFM_MODE	 64
#define OPT_MULTI_TRACK	128

#define return_MD	0x00000100
#define return_BC	0x00000200
#define return_SN	0x00000400
#define return_SH	0x00000800
#define return_NC	0x00001000
#define return_DD	0x00002000
#define return_CM	0x00004000

#define return_MA	0x00010000
#define return_NW	0x00020000
#define return_ND	0x00040000

#define return_OR	0x00100000
#define return_DE	0x00200000

#define return_EN	0x00800000
#define return_US0	0x01000000
#define return_US1	0x02000000
#define return_HD	0x04000000
#define return_NR	0x08000000
#define return_EC	0x10000000
#define return_SE	0x20000000
#define return_ICL	0x40000000
#define return_ICH	0x80000000

#define result_MD	0x01
#define result_BC	0x02
#define result_SN	0x04
#define result_SH	0x08
#define result_NC	0x10
#define result_DD	0x20
#define result_CM	0x40

#define result_MA	0x01
#define result_NW	0x02
#define result_ND	0x04

#define result_OR	0x10
#define result_DE	0x20

#define result_EN	0x80

#define result_US0	0x01
#define result_US1	0x02
#define result_HD	0x04
#define result_NR	0x08
#define result_EC	0x10
#define result_SE	0x20
#define result_ICL	0x40
#define result_ICH	0x80

extern int tsttimerD(void);
extern int diskbios(CMD_PARAM_BUF *);
