*
* $Project: dedit Disk EDITor for X680x0 $
* $Copyright: 1989-1993 by d(T.Kawamoto) $
* $Source: /home/src/cvs/dedit/lower.s,v $
* $Author: kawamoto $
* $Revision: 1.2 $
* $Date: 1993/10/24 18:37:20 $
* $Log: lower.s,v $
*	Revision 1.2  1993/10/24  18:37:20  kawamoto
*	*** empty log message ***
*
*	Revision 1.1  1993/10/24  17:42:40  kawamoto
*	version 2.24 first cvs importing
*
	.include	iocscall.mac
	.xref	SPeekA_from,SPeekA_resume
	.xref	SPeekB_from,SPeekB_resume
	.xref	SPeekC_from,SPeekC_resume
	.xref	RPeekA_from,RPeekA_resume
	.xref	RPeekB_from,RPeekB_resume
	.xref	RPeekC_from,RPeekC_resume

	.text
*
room	equ	4
*
*	InitNumber()
*
	globl	_InitNumber
_InitNumber:
	lea	table_head,a2
	moveq.l	#'0',d1
_InitNumber_loop1:
	bsr.s	_InitNumber_sub
	addq.b	#1,d1
	cmpi.b	#':',d1
	bne.s	_InitNumber_loop1
	moveq.l	#'A',d1
_InitNumber_loop2:
	bsr.s	_InitNumber_sub
	addq.b	#1,d1
	cmpi.b	#'G',d1
	bne.s	_InitNumber_loop2
	rts
*
_InitNumber_sub:
	move.l	d1,-(sp)
	moveq	#8,d2
	IOCS	__FNTADR
	movea.l	d0,a1
	moveq.l	#15,d1
	IOCS	__B_MEMSTR
	move.l	(sp)+,d1
	rts
*
*	DumpVisual(address)
*	address  real address
*
	globl	_DumpVisual
_DumpVisual:
	suba.l	a1,a1
	IOCS	__B_SUPER
	move.l	d0,-(sp)
	move.l	$8(sp),a0
	movem.l	d3-d7/a3-a5,-(sp)
	movea.l	#$E64818,a1
	move.l	#47,d0
	move.l	#128,d2
dump_vis_main_loop:
	movea.l	a1,a2
	move.l	#255,d1
dump_vis_minor_loop:
	move.b	(a0)+,(a2)
	adda.l	d2,a2
	dbra	d1,dump_vis_minor_loop
	tst.b	(a1)+
	dbra	d0,dump_vis_main_loop
	movem.l	(sp)+,d3-d7/a3-a5
	move.l	(sp)+,a1
	cmpa	#-1,a1
	beq	dump_vis_SUPER_skip
	IOCS	__B_SUPER
dump_vis_SUPER_skip:
	rts
*
*
*	Dump(address, base)
*	address  real address
*	base  base address
*
	globl	_Dump
_Dump:
ifdef	MOUSE
	jsr	_MS_CUROF
endif
	suba.l	a1,a1
	IOCS	__B_SUPER
	move.l	d0,-(sp)
	move.l	$8(sp),a0
	move.l	$C(sp),d0
	movea.l	#$E6400B,a1
	movem.l	d3-d7/a3-a6,-(sp)
	move.l	a0,d6
	sub.l	d0,d6
	moveq.l	#$F,d7
	lea	kanji_flag,a6
	clr.b	(a6)
Dumplp:
	bsr	prline
	add.l	#2048,a1
	addi.l	#16,d6
	dbra	d7,Dumplp
	movem.l	(sp)+,d3-d7/a3-a6
	move.l	(sp)+,a1
	cmpa	#-1,a1
	beq	Dump_SUPER_skip
	IOCS	__B_SUPER
Dump_SUPER_skip:
ifdef	MOUSE
	jsr	_MS_CURON
endif
	rts
*
*	Dump2(address, base, offset)
*	address  real address
*	base  base address
*	offset  part offset
*
	globl	_Dump2
_Dump2:
ifdef	MOUSE
	jsr	_MS_CUROF
endif
	suba.l	a1,a1
	IOCS	__B_SUPER
	move.l	d0,-(sp)
	move.l	$8(sp),a0
	move.l	$C(sp),d0
	move.l	$10(sp),d1
	movea.l	#$E6400B,a1
	cmpi.l	#16,d1
	bcc	Dump2end
	movem.l	d3-d7/a3-a6,-(sp)
	lea	kanji_flag,a6
	add.l	d1,a6
	move.b	1(a6),las_kanji_flag
	asl.l	#4,d1
	add.l	d1,a0
	asl.l	#7,d1
	add.l	d1,a1
	move.l	a0,d6
	sub.l	d0,d6
	bsr	prline
	moveq	#0,d1
	move.b	(a6),d1
	cmp.b	las_kanji_flag,d1
	seq	d1
	movem.l	(sp)+,d3-d7/a3-a6
Dump2end:
	move.l	(sp)+,a1
	cmpa	#-1,a1
	beq	Dump2_SUPER_skip
	IOCS	__B_SUPER
Dump2_SUPER_skip:
	move.l	d1,d0
ifdef	MOUSE
	move.l	d0,-(sp)
	jsr	_MS_CURON
	move.l	(sp)+,d0
endif
	rts
*
*	ScrollKanjiFlag(direction)
*
	globl	_ScrollKanjiFlag
_ScrollKanjiFlag:
	move.l	$4(sp),d0
	cmpi.l	#1,d0
	bne	sckjfgdn
sckjfgup:
	lea	kanji_flag+1,a0
	lea	kanji_flag,a1
	moveq.l	#15,d0
sckjfguplp:
	move.b	(a0)+,(a1)+
	dbra	d0,sckjfguplp
	rts

sckjfgdn:
	lea	kanji_flag+16,a0
	lea	kanji_flag+17,a1
	moveq.l	#15,d0
sckjfgdnlp:
	move.b	-(a0),-(a1)
	dbra	d0,sckjfgdnlp
	rts
*
*	Print(locx, locy, ptr)
*	locx locy  location
*	ptr  buffer
*
	globl	_Print
_Print:
ifdef	MOUSE
	jsr	_MS_CUROF
endif
	suba.l	a1,a1
	IOCS	__B_SUPER
	move.l	d0,-(sp)
	move.l	$8(sp),d0
	move.l	$C(sp),d1
	move.l	$10(sp),a0
	movem.l	d3-d7/a3-a5,-(sp)
	asl.l	#8,d1
	asl.l	#3,d1
	movea.l	#$E60000,a1
	add.l	d0,a1
	add.l	d1,a1
	move.l	a0,a5
	move.l	a1,a4
Printlp:
	tst.b	(a5)
	beq	Printed
	bsr	prchar
	bra	Printlp

Printed:
	movem.l	(sp)+,d3-d7/a3-a5
	move.l	(sp)+,a1
	cmpa	#-1,a1
	beq	Print_SUPER_skip
	IOCS	__B_SUPER
Print_SUPER_skip:
ifdef	MOUSE
	jsr	_MS_CURON
endif
	rts
*
*	global registers
*		d6	head address1
*		a0	head address2
*		a1	text offset
*
*
*	enter registers
*	use registers d0 d2 d3 d4 d5 a2 a3 a4 a5
*
prline:
	move.l	a1,a4
	move.l	d6,d0
	swap	d0
	asr.w	#8,d0
	bsr	prbyte
	move.l	d6,d0
	swap	d0
	bsr	prbyte
	move.l	d6,d0
	asr.w	#8,d0
	bsr	prbyte
	move.l	d6,d0
	bsr	prbyte
	tst.b	(a4)+
	moveq.l	#$F,d3
prlnlp1:
		clr.b	(_BusErrorDetected)
bus_1_from:
		nop
		move.b	(a0),d0		* the addressing may be a bus error
		nop
bus_1_resume:
		addq.l	#1,a0
		tst.b	(_BusErrorDetected)
		beq	1f
		bsr	prmesh
		bra	2f
1:		bsr	prbyte
2:
	tst.b	(a4)+
	dbra	d3,prlnlp1
	lea	-16(a0),a5
	tst.b	(a6)+
	beq	prlnlp2
	lea	space,a5
	bsr	prchar
	lea	-15(a0),a5
prlnlp2:
	cmp.l	a0,a5
	beq	prlnnt
	bpl	prlned
	bsr	prchar
	bra	prlnlp2

prlnnt:
	lea	space,a5
	bsr	prchar
	clr.b	(a6)
	rts

prlned:
	move.b	#$FF,(a6)
	rts
*
*	enter registers	a4 a5
*	use registers	d0 d1 d2 d4 d5 a2 a3
*
prchar:
	clr.w	d1
		bsr	getchar
	cmpi.b	#$80,d1
	bcs	prchbyt
	cmpi.b	#$A0,d1
	bcs	prchkan
	cmpi.b	#$E0,d1
	bcs	prchbyt
prchkan:
	asl	#8,d1
		bsr	getchar
	moveq.l	#8,d2
	IOCS	__FNTADR
	tst.w	d1
	beq	prchhan
	move.l	d0,a2
	move.l	a4,a3
	move.l	#127,d5
	moveq.l	#15,d4
prchkanlp:
	move.b	(a2)+,(a3)+
	move.b	(a2)+,(a3)
	add.l	d5,a3
	dbra	d4,prchkanlp
	tst.b	(a4)+
	tst.b	(a4)+
	rts

prchhan:
	move.l	d0,a2
	move.l	a4,a3
	move.l	#128,d5
	moveq.l	#15,d4
prchhanlp1:
	move.b	(a2)+,(a3)
	add.l	d5,a3
	dbra	d4,prchhanlp1
	tst.b	(a4)+
	lea	mesh,a2
	move.l	a4,a3
	moveq.l	#15,d4
prchhanlp2:
	move.b	(a2)+,(a3)
	add.l	d5,a3
	dbra	d4,prchhanlp2
	tst.b	(a4)+
	rts

prchbyt:
	moveq.l	#8,d2
	IOCS	__FNTADR
	move.l	d0,a2
	move.l	a4,a3
	move.l	#128,d5
	moveq.l	#15,d4
prchbytlp:
	move.b	(a2)+,(a3)
	add.l	d5,a3
	dbra	d4,prchbytlp
	tst.b	(a4)+
	rts

getchar:
bus_2_from:
		nop
		move.b	(a5),d1		* the addressing may be a bus error
		nop
bus_2_resume:
		addq.l	#1,a5
		rts

prmesh:
		pea	(@f,pc)
@@:		lea	(mesh),a2
		bra	prmesh_sub

*
*	enter registers	d0 a4
*	use registers	d4 d5 a2 a3
*
prbyte:
	move.l	d0,d4
	bsr	prnible
	move.l	d0,d4
	asl.b	#4,d4
prnible:
	andi.l	#$F0,d4
	lea	table_head,a2
	add.l	d4,a2
prmesh_sub:
	move.l	a4,a3
	move.l	#128,d5
	moveq.l	#15,d4
prbtlp:
	move.b	(a2)+,(a3)
	add.l	d5,a3
	dbra	d4,prbtlp
	tst.b	(a4)+
	rts

*
*	bus error handler
*
*
	globl	_BusErrorForX68030
	globl	_BusErrorForX68000
	globl	_LastBusError
	globl	_BusErrorDetected

_BusErrorForX68000:
		move.l	d0,-(sp)
		move.l	(4+10,sp),d0
		bsr	BusError_check2
		beq	BusError000_dflt

		st	(_BusErrorDetected)
		move.l	d0,(4+10,sp)
		move.l	(sp)+,d0
		addq.l	#8,sp
		rte

BusError000_dflt:
		move.l	(sp),d0
		move.l	_LastBusError,(sp)
		rts

* Format $8 (68010)	  Bus Error
* Format $A (68020/68030) Short Bus Cycle
* Format $B (68020/68030) Long Bus Cycle
* Format $7 (68040)	  Access Fault
* Format $4 (68060)	  Access Fault

_BusErrorForX68030:
		move.l	d0,-(sp)
		move.b	(4+6,sp),d0
		lsr.b	#4,d0
		subq.b	#$4,d0
		beq	BusError030_6
		subq.b	#$b-$4,d0
		beq	BusError030_23
BusError030_dflt:
		move.l	(sp),d0
		move.l	_LastBusError,(sp)
		rts

* 68060 Access Fault
BusError030_6:
		bsr	BusError_check
		beq	BusError030_dflt

		st	(_BusErrorDetected)
		move.l	d0,(4+2,sp)
		move.l	(sp)+,d0
		rte

* 68020/68030 Long Bus Cycle
BusError030_23:
		bsr	BusError_check
		beq	BusError030_dflt

		st	(_BusErrorDetected)
		move.l	(sp)+,d0
		clr.l	(44,sp)
		andi	#$feff,(10,sp)
		rte

BusError_check:
		move.l	(4+4+2,sp),d0
BusError_check2:
		cmpi.l	#bus_1_from,d0
		bcs	@f
		cmpi.l	#bus_1_resume+room,d0
		bcs	BusError_chk1
		cmpi.l	#bus_2_from,d0
		bcs	BusError_chkNULL
		cmpi.l	#bus_2_resume+room,d0
		bcs	BusError_chk2
@@:
		cmpi.l	#SPeekA_from,d0
		bcs	@f
		cmpi.l	#SPeekA_resume+room,d0
		bcs	BusError_chkSA
@@:
		cmpi.l	#SPeekB_from,d0
		bcs	@f
		cmpi.l	#SPeekB_resume+room,d0
		bcs	BusError_chkSB
@@:
		cmpi.l	#SPeekC_from,d0
		bcs	@f
		cmpi.l	#SPeekC_resume+room,d0
		bcs	BusError_chkSC
@@:
		cmpi.l	#RPeekA_from,d0
		bcs	@f
		cmpi.l	#RPeekA_resume+room,d0
		bcs	BusError_chkRA
@@:
		cmpi.l	#RPeekB_from,d0
		bcs	@f
		cmpi.l	#RPeekB_resume+room,d0
		bcs	BusError_chkRB
@@:
		cmpi.l	#RPeekC_from,d0
		bcs	@f
		cmpi.l	#RPeekC_resume+room,d0
		bcs	BusError_chkRC
@@:
BusError_chkNULL:
		moveq	#0,d0
		rts

BusError_chk1:
		move.l	#bus_1_resume,d0
		rts
BusError_chk2:
		move.l	#bus_2_resume,d0
		rts
BusError_chkSA:
		move.l	#SPeekA_resume,d0
		rts
BusError_chkSB:
		move.l	#SPeekB_resume,d0
		rts
BusError_chkSC:
		move.l	#SPeekC_resume,d0
		rts
BusError_chkRA:
		move.l	#RPeekA_resume,d0
		rts
BusError_chkRB:
		move.l	#RPeekB_resume,d0
		rts
BusError_chkRC:
		move.l	#RPeekC_resume,d0
		rts

	.data

mesh:
	.dc.b	$00,$54,$00,$54,$00,$54,$00,$54,$00,$54,$00,$54,$00,$54,$00,$00
space:
	.dc.b	' '
_BusErrorDetected:
	.dc.b	0

	.bss

table_head:
	.ds.b	256
_LastBusError:
	.ds.l	1
kanji_flag:
	.ds.b	17
las_kanji_flag:
	.ds.b	1

	.end
