/*
 * $Project: dedit Disk EDITor for X680x0 $
 * $Copyright: 1989-1993 by d(T.Kawamoto) $
 * $Source: /home/src/cvs/dedit/dedit.h,v $
 * $Author: kawamoto $
 * $Revision: 1.3 $
 * $Date: 1994/04/23 11:35:52 $
 * $Log: dedit.h,v $
 *	Revision 1.3  1994/04/23  11:35:52  kawamoto
 *	hLgC
 *
 *	Revision 1.2  1993/10/24  18:33:44  kawamoto
 *	*** empty log message ***
 *
 *	Revision 1.1  1993/10/24  17:39:24  kawamoto
 *	version 2.24 first cvs importing
 */

#include <iocslib.h>
#include <doslib.h>
#include <string.h>
#include <stdlib.h>
#include <jstring.h>
#include <ctype.h>
#include <jctype.h>

#ifdef __LIBC__
typedef char schar;
#else
typedef unsigned char schar;
#define _filbuf FILBUF
#define ide id
#endif

typedef unsigned char uchar;
typedef unsigned short ushort;
typedef unsigned long ulong;
#ifndef NULL
#define NULL 0
#endif
#define ERROR (-1)
#define FUNC_PRE (-1)
#define FUNC_NORMAL (-1)
#define FUNC_ERROR (-2)

typedef struct DIRENTRY {
  char fileName[8];
  char ext[3];
  uchar atr;
  char fileName2[10];
  uchar time[2];
  uchar date[2];
  uchar fatNo[2];
  uchar fileLen[4];
} direntry;

#define HenEND		0
#define HenDRIVE	1
#define HenSOUCHI	2
#define HenTRACK	3
#define HenSECTOR	4
#define HenREAD		5
#define HenLOAD		6
#define HenADDR		7
#define HenDIR		8

/*	sub routines	*/

/* subrtns.c */
extern int CurDrive;
extern int UserLevel;

#define NO_WRITING_USER 0
#define HUMAN_DISK_USER 1
#define LEVEL2_USER 2
#define LEVEL3_USER 3
#define LEVEL4_USER 4
#define EXPERT_USER 5

extern struct DPBPTR DPBbuf;
extern int Is2Bytes;

extern char
   Mes22Spaces[], *MesNILL, *Mes2Spaces, *Mes4Spaces, *Mes6Spaces, *Mes17Spaces,
  *MesESCend, *MesWhichSelectQ, *MesRetMain, *MesControl, *MesTenKey,
  *MesAddress, *MesRGB,
  *MesValueUpDown, *MesCursScrl, *MesCurs, *MesCursLURD, *MesCursUD,
  *MesHomeReturn, *MesRetESC, *MesAllreadyExist, *MesOverWrite,
  *MesFKeyBar, *MesFKeyChar, *MesFKeyDrive, *MesFKeyDriveC, *MesFKeyReadC,
  *MesFKeyWriteC, *MesFKeyLoadC, *MesFKeySaveC,
  *MesFKeyNxtSctrC, *MesFKeyLstSctrC, *MesFKeyHdSctrC, *MesFKeySctrNoC,
  *MesFKeyNxtTrckC, *MesFKeyLstTrckC, *MesFKeyHdTrckC, *MesFKeyTrckNoC,
  *MesFKeyAdrsC,
  *MesFKeyRange, *MesFKeySort, *MesFKeyName, *MesFKeySave, *MesFKeyUndel,
  *MesFKeyNxtClst, *MesFKeyLstClst, *MesFKeyHdClst, *MesFKeyClstNo,
  *MesWriteOKQ, *MesDriveNameQ, *MesDriveNoQ, *MesDiskTypeQ, *MesTrackNoQ,
  *MesDiskFull, *MesIlleName, *MesDriveNo, *MesTrackNo, *Mes2HD, *Mes2DD,
  *MesSingle, *MesDouble, *MesResult, *MesDensity,
  *MesSCSIorSASIQ, *MesSCSIidQ, *MesSouchiNoQ;

extern void Assigned_path(char *, int);
extern void Pre(void);
extern int GetDPB(int);
extern void Post(void);
#define OutOfMemory 1
extern void NulFuncKey(void);
extern int FATnoToSector(int);
extern int NextFATNo(uchar *, int);
extern int FATnoOk(uchar *, int);
extern void Scroll(int, int, int, int);
extern void Window(int, int, int, int);
extern void YLine(int, int, int);
extern void Clear23(void);
extern void CurXor(int, int, int);
extern void WaitForAMoment(int);
extern int FileSave(char *, schar *, int);

extern void ClearPath(void);
extern void SetPath(char *, char *);
extern void PrintPath(void);
extern int ToChild(direntry *, int, int);
extern int ToParent(int *);

extern uchar *Malloc(int);

/* lower.s */
extern void InitNumber(void);
extern void DumpVisual(uchar *);
extern void Dump(int, int);
extern int Dump2(int, int, int);
extern void ScrollKanjiFlag(int);
extern void Print(int, int, uchar *);

/* provisional adjusts */
typedef struct {
  short function : 1;
  short selection : 1;
} provisional;

extern provisional Provisional_adjusts;

#ifdef __CRLF__
#define CRLF "\r\n"
#else
#define CRLF "\n"
#endif

/* EOF */
