/*
 * $Project: dedit Disk EDITor for X680x0 $
 * $Copyright: 1989-1993 by d(T.Kawamoto) $
 * $Source: /home/src/cvs/dedit/search.h,v $
 * $Author: kawamoto $
 * $Revision: 1.2 $
 * $Date: 1993/10/24 18:38:02 $
 * $Log: search.h,v $
 *	Revision 1.2  1993/10/24  18:38:02  kawamoto
 *	*** empty log message ***
 *
 *	Revision 1.1  1993/10/24  17:43:26  kawamoto
 *	version 2.24 first cvs importing
 */

typedef enum BOOL {
  true = 1, false = 0
} bool;

#define CHAR_MAX 257
extern int SPeek(uchar *);
typedef uchar skip[258];

typedef struct _SEARCH {
  int tar_size;		/* the size of the target, which equals to */
			/*                  tar_end - tar_top + 1 */
  uchar *tar_top;	/* the top character of the target */
  uchar *tar_cur;	/* the current watching character of the target */
  uchar *tar_end;	/* the end character of the target */
  skip *sk_top;		/* the first skip table for search */
  skip *sk_end;		/* the last skip table for search */
  uchar *buf_top;	/* the top character of the buffer */
  uchar *buf_cur;	/* the current watching character of the buffer */
  uchar *buf_end;	/* the end character of the buffer */
} srchbuf;

extern bool search(srchbuf *bptr);
extern void search_init(srchbuf *bptr, bool (*buffer_read)(void));
extern bool rearch(srchbuf *bptr);
extern void rearch_init(srchbuf *bptr, bool (*buffer_read)(void));

/* initialization for memory search */
extern void memSearchInit(uchar *, srchbuf *, int);
